VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "MSHFLXGD.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2535
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6585
   LinkTopic       =   "Form1"
   ScaleHeight     =   2535
   ScaleWidth      =   6585
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Clear 
      Caption         =   "Clear"
      Height          =   495
      Left            =   2160
      TabIndex        =   3
      Top             =   1920
      Width           =   1095
   End
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid MSHFlexGrid1 
      Height          =   1575
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   6255
      _ExtentX        =   11033
      _ExtentY        =   2778
      _Version        =   393216
      _NumberOfBands  =   1
      _Band(0).Cols   =   2
   End
   Begin VB.CommandButton Read 
      Caption         =   "Read Data"
      Enabled         =   0   'False
      Height          =   495
      Left            =   5160
      TabIndex        =   1
      Top             =   1920
      Width           =   1215
   End
   Begin VB.CommandButton Create 
      Caption         =   "Create DB"
      Height          =   495
      Left            =   3600
      TabIndex        =   0
      Top             =   1920
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private mConn As ADODB.Connection 'connection used through out in the form

'/////////////////////////////////////////////////////////////////////
'//Synposis:
'//1. Create a table named cust if it does not exist. If the table exits,
'//delete all records from the table.
'//2. Insert some records into cust table
'//3. Update the records using parameters which makes it easy for
'//binary data manipulation
'/////////////////////////////////////////////////////////////////////
Private Sub Create_Click()
    On Error GoTo Trap
    Dim cmd As New ADODB.Command
    cmd.ActiveConnection = mConn
    
    
    If HasCustTable Then    'delete all data from the table if table exists
        cmd.CommandText = "DELETE FROM cust;"
    Else  'create cust table if it does not exists
        cmd.CommandText = "CREATE TABLE cust(ID INTEGER PRIMARY KEY, Name VARCHAR(60), Address VARCHAR(120), Picture BLOB);"
    End If
    cmd.Execute
    cmd.CommandText = ""
    
    'insert data
    Dim I As Integer
    For I = 100 To 110
        cmd.CommandText = cmd.CommandText + "INSERT INTO cust (ID, Name) VALUES (" & I & ", 'Sean " & I & "');"
    Next I
    cmd.Execute
    
    'update records with Parameters
    Dim BA(999) As Byte
    For I = 0 To 999
        BA(I) = (I + 1) Mod 256
    Next I
    Dim params(2) As Parameter
    Set params(0) = New ADODB.Parameter
    params(0).Type = adInteger 'integer
    params(0).Value = 100
    Set params(1) = New ADODB.Parameter
    params(1).Type = adBSTR     'string
    params(1).Value = "1010 Main St, Salem, OR"
    Set params(2) = New ADODB.Parameter
    params(2).Type = adBinary
    params(2).Value = BA
    params(2).Size = 1000
    cmd.CommandText = "UPDATE cust SET Address=?, Picture=? WHERE ID=?;"
    'add parameters according to commend text
    cmd.Parameters.Append params(1)
    cmd.Parameters.Append params(2)
    cmd.Parameters.Append params(0)
    cmd.Execute
    
    'using transaction
    params(0).Value = 101
    mConn.BeginTrans
    cmd.Execute
    mConn.RollbackTrans 'the address is NOT updated when read back
    params(0).Value = 102
    mConn.BeginTrans
    cmd.Execute
    mConn.CommitTrans 'the address is updated when read back
    
    Set cmd = Nothing
    MsgBox "Done"
    Exit Sub
Trap:
    MsgBox Err.Description
End Sub
'/////////////////////////////////////////////////////////////////////1
'//Synposis:
'//Create a recordset to get all data from cust table and present the
'//data in a data grid.
'//To view the binary data read back from the database, you may open
'//open a watch window in the debug mode
'/////////////////////////////////////////////////////////////////////
Private Sub Read_Click()
    Dim BA() As Byte

    On Error GoTo Trap
    Me.MSHFlexGrid1.Clear
    Dim Rs As New ADODB.Recordset
    Rs.Open "SELECT * FROM cust;", mConn
    'If Not Rs.EOF Then
    '    BA = Rs("Picture").Value 'add to watch window to view byte array
    'End If
    Set Me.MSHFlexGrid1.Recordset = Rs
    Exit Sub
Trap:
    MsgBox Err.Description
    
End Sub
'/////////////////////////////////////////////////////////////////////
'//Synposis:
'//Clear all data from the data grid
'/////////////////////////////////////////////////////////////////////
Private Sub Clear_Click()
    Me.MSHFlexGrid1.Clear
End Sub
'/////////////////////////////////////////////////////////////////////
'//Synposis:
'//1. Create an ADO connection
'//2. Enable Read Data button if the table exists
'/////////////////////////////////////////////////////////////////////
Private Sub Form_Load()
    On Error GoTo Trap
    Set mConn = New ADODB.Connection
    mConn.Open "Provider=OleSQLite.SQLiteSource.1; Data Source=C:\customer.dat"
    If HasCustTable Then
        Me.Read.Enabled = True
    End If
    Exit Sub
Trap:
    MsgBox Err.Description
End Sub
'/////////////////////////////////////////////////////////////////////
'//Synposis:
'//Check if the cust table exists. Return true if it does. Return false
'//otherwise.
'/////////////////////////////////////////////////////////////////////
Private Function HasCustTable() As Boolean
    Dim Rs As ADODB.Recordset
    Set Rs = mConn.OpenSchema(adSchemaTables)
    While Not Rs.EOF
        If Rs("table_name").Value = "cust" Then
            HasCustTable = True
            GoTo funExit
        End If
        Rs.MoveNext
    Wend
funExit:
    Rs.Close
    Set Rs = Nothing
End Function
